
#include "base.cpp"
#include "conjuntosoluciones.cpp"



class Problema {
//Declaraciones privadas de la clase
private:
int p,q;
int *a;
void insertar(int ii,int i);


//Declaraciones publicas de la clase
public:
Problema(int minimo,int maximo);
Problema(int minimo,int maximo,int i1,int i2,int i3,int i4,int i5,int i6,int i7,int i8,int i9,int i10);
bool pequeno(Base * base);

Solucion * solucion();
Solucion * solucion2();
ConjuntoSoluciones *dividir_recursivo(Base * b);
Solucion * combinar(ConjuntoSoluciones * s);
void mostrar();
~Problema();
};


Problema::Problema(int minimo,int maximo) {

	p=minimo;
	q=maximo;
	a = new int[q-p+1];
}


bool Problema::pequeno(Base *base) {
	if (base->menor(p,q)) {
 
               return true;         
}
else {
     return false;
     }

}


      

Solucion * Problema::solucion() {
         int i,j,tmp;
         int aux[q-p+1];
         j=0;
            
         for (i=p;i<=q;i++) {
          aux[j++]=a[i];
       
         }
         int max=q-p+1;
         Solucion * s = new Solucion(q-p+1);
         
         if (q==p) {
                   
            s->insertar(0,aux[p]);
           
         }
         else {
         
         for (i=0;i<max-1;i++) {
             for (j=i+1;j<max;j++) {
                 if (aux[j]<aux[i]) {
                    tmp=aux[j];
                    aux[j]=aux[i];
                    aux[i]=tmp;
                 }
             }
         }
         for (i=0;i<max;i++) {
             s->insertar(i,aux[i]);   
         }
         }
         return s;
}

      
ConjuntoSoluciones * Problema:: dividir_recursivo(Base * b) {
	int temp, v, i ,d;
	ConjuntoSoluciones * c;
	v=a[p];
	i=p;
	d=q+1;
	do {

		i=i+1;

	} while ((i<q)&&(a[i]<=v));
	do {
		d=d-1;
	} while (a[d]>v);
	while (i<d) {
		temp=a[i];
		a[i]=a[d];
		a[d]=temp;
		do {
			i=i+1;
		} while (a[i] <=v);
		do {
			d=d-1;
		} while (a[d]>v);
		
	}
	a[p]=a[d];
	a[d]=v;

   Problema * p1 = new Problema(p,d);
   int iii=0;
   int ii;
  
   	for (ii=p;ii<=d;ii++) {
		p1->insertar(iii++,a[ii]);
	}
   
   Problema * p2 = new Problema(0,q-d-1);   
   iii=0;
   for (ii=d+1;ii<=q;ii++) {
		p2->insertar(iii++,a[ii]);
	}

	Solucion * s1 = divide_venceras(p1,b);
	Solucion * s2 = divide_venceras(p2,b);
	c = new ConjuntoSoluciones(s1,s2);
	
	return c;
	
}



      
Solucion * Problema::combinar(ConjuntoSoluciones * s) {
	

    Solucion * solucion =new Solucion (q-p+1);
    
    Solucion * s1 = s->obtenerSolucion(1);
    Solucion * s2 = s->obtenerSolucion(2);
   
    for (int i=0;i<q-p+1;i++) {
        int t = s1->tamano();
        
        if (i<s1->tamano()) 
           {
                             
                             solucion->insertar(i,s1->obtener(i));
                             }
        else  {
              solucion->insertar(i,s2->obtener(i-s1->tamano()));  
             
              }
        
    }
	return solucion;
}



      
Problema::~Problema() {

}




      
//Otras funciones auxiliares

Problema::Problema(int minimo,int maximo,int i1,int i2,int i3,int i4,int i5,int i6,int i7,int i8,int i9,int i10) {

	p=minimo;
	q=maximo;
	a = new int[q-p+1];
	a[0]=i1;
	a[1]=i2;
	a[2]=i3;
	a[3]=i4;
	a[4]=i5;
	a[5]=i6;
	a[6]=i7;
	a[7]=i8;
	a[8]=i9;
	a[9]=i10;


}
//Para base=2
Solucion * Problema::solucion2() {
	int temp;


	Solucion * s;
	if ((q-p)==0) {
  s = new Solucion(1); 
  s->insertar(0,a[q]);                
}
else {
	 s = new Solucion(q-p+1);
	 if (a[q]<=a[p]) {
	s->insertar(0,a[q]);
	s->insertar(1,a[p]);
} else {
      s->insertar(1,a[q]);
	s->insertar(0,a[p]); 
       }
}
	
	return s;
}
void Problema::insertar(int ii, int i) {
     a[ii]=i;
}
void Problema::mostrar() {
 	int i;
	for (i=0;i<q-p+1;i++) {
		cout << a[i] <<" ";

	}

	cout << "\n";
}


