#include "lista.cpp"

class Problema {
//Declaraciones privadas de la clase
private:
double *p;
double *b;
double M;
int tam;


//Declaraciones publicas de la clase
public:
Problema();
double CS(Nodo *nodo);
double CI(Nodo *nodo);
double coste(Nodo *nodo);
Lista* obtenerHijos(Nodo *nodo);
bool mejorSolucionFinal(Nodo *nodoY, Nodo *nodoS);
double mejor(double x, double y);
bool solucionFinal(Nodo *nodo);
~Problema();
Problema(double a1,double a2,double a3,double a4,double a5,
		   double p1,double p2,double p3,double p4,double p5);

};

Problema::Problema() {
//Vacio
}


double Problema::CS(Nodo *nodo) {
	int i=0;
	double aux =0;
	while (nodo->solucion[i]!=-1 && i < tam){
			aux = aux + nodo->solucion[i]*p[i]*b[i];
			i++;
	}

	for (i = nodo->getNivel() + 1; i < tam ; i++) aux = aux + p[i]*b[i];

	return aux;

}

double Problema::CI(Nodo *nodo) {
    int i=0;
	 double aux =0;
	while (nodo->solucion[i]!=-1 && i < tam){
			aux = aux + nodo->solucion[i]*p[i]*b[i];
			i++;
	}

	

	return aux;
}

double Problema::coste(Nodo *nodo) {
	return  (CS(nodo)+CI(nodo))/2;	
}

Lista* Problema::obtenerHijos(Nodo *nodo) {
Lista *hijos = new Lista();
int i=0;
Nodo *nodo0 =  new Nodo(nodo->getTam());Nodo *nodo1 =  new Nodo(nodo->getTam());
nodo->setNivel(nodo->getNivel()+1);

nodo0->solucion = new int[tam];nodo1->solucion = new int[tam];
for (i=0;i<tam;i++) {
	nodo0->solucion[i] = nodo->solucion[i];
	nodo1->solucion[i] = nodo->solucion[i];
}



nodo0->solucion[nodo->getNivel()] =0;
nodo1->solucion[nodo->getNivel()] =1;

nodo0->setNivel(nodo->getNivel());
nodo0->setCS(CS(nodo0));
nodo0->setCI(CI(nodo0));
nodo0->setBE(coste(nodo0));
nodo0->setPact(nodo->getPact());

nodo1->setNivel(nodo->getNivel());
nodo1->setCS(CS(nodo1));
nodo1->setCI(CI(nodo1));
nodo1->setBE(coste(nodo1));
nodo1->setPact(nodo->getPact() + p[nodo->getNivel()]);


if (nodo1->getPact()<=M) {
	hijos->Insertar(nodo1);
}

hijos->Insertar(nodo0);

return hijos;
}

bool Problema::mejorSolucionFinal(Nodo *nodoY, Nodo *nodoS){
        if (solucionFinal(nodoY))
                if (nodoY->getBE()>=nodoS->getBE()) return true;
        return false;
}

double Problema::mejor(double x, double y) {
  if (x>y) return x;
  return y;
}

bool Problema::solucionFinal(Nodo *nodo) {
        if (nodo->getNivel()==tam-1) return true;
        return false;
}

Problema::~Problema() {

}


//Otras funciones auxiliares

Problema::Problema(double a1,double a2,double a3,double a4,double a5,
		   double p1,double p2,double p3,double p4,double p5) {
	tam = 5;
	b = new double[tam];
	p = new double[tam];
	
	
	b[0] = a1;b[1] = a2;b[2] = a3; b[3] = a4; b[4] = a5;
	p[0] = p1;p[1] = p2;p[2] = p3; p[3] = p4; p[4] = p5;
	
	M = 8;
}

