
#include "nodo.cpp"



class Celda {
   public:
   Nodo valor;
   Celda *siguiente;
   Celda(Nodo nodo, Celda *sig = NULL)
   {
	
	valor = nodo;
	siguiente = sig;
    }

    friend class lista;

};

typedef Celda *pcelda;

class Lista {
   public:
    Lista() { anterior = primero = actual = NULL; }
    ~Lista();

    void Insertar(Nodo *nodo);
    void InsertarLNV(Nodo *nodo);
    void Borrar();
    bool ListaVacia() { return (primero== NULL || longitud==0); }
    void Siguiente();
    void Primero();
    bool Actual() { return actual != NULL; }
    Nodo* ValorActual() { return &actual->valor; }
    int Longitud() { return longitud; }


   private:
    pcelda primero;
    pcelda anterior;
    pcelda actual;
    int longitud ;
};

Lista::~Lista()
{
   pcelda aux;
   int cont = longitud;
   while(cont!=0) {
      Primero();
      Borrar();
      cont--;

   }

primero = NULL;
actual = NULL;
anterior = NULL;
}




void Lista::Insertar(Nodo *nodo)
{
	if(ListaVacia()) {	

		primero = new Celda(*nodo, primero);
		if (anterior!=NULL) {
			nodo->mostrar();
			delete anterior;
		}
		anterior = NULL;
		actual = primero;
		longitud = 1;
	}
	else {
		anterior = actual;
		actual->siguiente = new Celda(*nodo,anterior->siguiente);
		actual = actual -> siguiente;
		longitud++;
	}
}

void Lista::Borrar()
{
	pcelda siguiente,aux;

	if (actual->siguiente == NULL) {

		if (actual == primero) {
			delete primero;
			actual = NULL;primero=NULL;

		}
		else{
			delete actual;
			actual = anterior;
			actual->siguiente = NULL;
			aux = primero;
			while (aux!=actual){
				anterior = aux;
				aux = aux->siguiente;
			}
		}
	}
	else{
		if (actual == primero) {
			primero = actual->siguiente;
			anterior = NULL;
			delete actual;
			actual = primero;

		}
		else{
			actual = actual->siguiente;
			delete anterior->siguiente;
			anterior->siguiente = actual;

		}

	}
	longitud--;
}



void Lista::Siguiente()
{

   anterior = actual;
   actual = actual->siguiente;
}

void Lista::Primero()
{

   anterior = NULL;
   actual = primero;
}

void Lista::InsertarLNV(Nodo *nodo){
Primero();
Insertar(nodo);
}
