package BACK;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import modelo.Accion;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

public class AccionCargarFicheroMainBACK implements Accion{
	
	public String ejecutar(HttpServletRequest peticion,
			HttpServletResponse respuesta, ServletContext aplicacion) {
		HttpSession sesion = peticion.getSession();
		
		try{
			

		//Subimos el fichero y lo dejamos en la carpeta del algoritmo del usuario
		
		boolean isMultipart = ServletFileUpload.isMultipartContent(peticion);
		DiskFileItemFactory factory = new DiskFileItemFactory();
		//maxima talla que sera guardada en memoria
		factory.setSizeThreshold(4096);
		
		//si se excede de la anterior talla, se ira guardando temporalmente, en la sgte direccion
		factory.setRepository(new File("/home/"));
		ServletFileUpload upload = new ServletFileUpload(factory);
		//maxima talla permisible (si se excede salta al catch)
		upload.setSizeMax(10000000);
		List fileItems = upload.parseRequest(peticion);
		
		
		HttpSession actualSession = peticion.getSession(true);
		String direc = aplicacion.getRealPath("/") + actualSession.getAttribute("id") +"/" + actualSession.getAttribute("algoritmo")+"/";
		File directorio = new File(direc);
	 	directorio.mkdir();
		
		//obtiene el file enviado
		FileItem fi =null;
		int cont = 0;
		Iterator i = fileItems.iterator();
		if (i.hasNext()){
		 fi = (FileItem)i.next();
		// System.out.println("Tamaño "+fi.getSize());
			//graba el file enviado en el servidor local
			//path y Nombre del archivo destino (en el server)
		 if (fi.getSize()!=0) {	
		 	String path = direc;
			String fileName="codigoMain.cpp";
			fi.write(new File(path, fileName));
			cont++;
		 }
		}
		
		//Una vez subido, comenzamos a leerlo.
		
		String dirAplicacion = aplicacion.getRealPath("/");
		String direccion = dirAplicacion + "/"+ sesion.getAttribute("id") + "/"
		+ sesion.getAttribute("algoritmo") + "/";
		
		
		UtilidadesCargarFichero.cargarMain(sesion, direccion + "codigoMain.cpp", aplicacion);
		UtilidadesCargarFichero.cargarLista(sesion, direccion + "lista.cpp", aplicacion);
		
				
		}catch(Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

		 return "backtracking.jsp";
		
		}
}

