#include "solucion.cpp"
#include "datosiniciales.cpp"
#include "iterador.cpp"
class Datos {

//Declaraciones privadas de la clase

private:

int * a;
int tam;
//Declaraciones publicas de la clase

public:

Datos(int n);
void inicializar(DatosIniciales * datosIniciales);
Iterador * iterador();
void calcularActual(Dato * d);
Solucion * componerSolucion();
~Datos();

int obtener(int i);
int tamano();
void mostrar();

};



Datos::Datos(int n) { 
	a = new int[n];
	tam = n;
}
void Datos::inicializar(DatosIniciales * datosIniciales) { 
	a[0]=1;
	a[1]=1;
}
Iterador * Datos::iterador() { 
	return new Iterador(2,tam);
}
void Datos::calcularActual(Dato * d) {
	int aux = d->obtener();
	//printf("aux %d\n",aux);
	a[aux]=a[aux-1]+a[aux-2];
 }
Solucion * Datos::componerSolucion() { 
mostrar();
return new Solucion(a[tam-1]);

}
Datos::~Datos() { }
//Otras funciones aux

int Datos::obtener(int i) {
	return a[i];
}
int Datos::tamano() {
	return tam;
}
void Datos::mostrar() {
	for(int i=0;i<tam;i++) {
		printf(" %d",a[i]);
	}
	printf("\n");
}

