package modelo;

public interface ClienteDAO {
	public Cliente create( String usuario, String clave, String direc)throws DAOException;
	public Cliente findClienteByUsuario(String usuario, String direc)throws DAOException;
	public String findAll(String direc) throws DAOException;
	public void update (Cliente c) throws DAOException;
	public Cliente findClienteByPassword(String password) throws DAOException;
	public boolean ponerContrasena(Cliente c, String direc) throws DAOException;
	public boolean quitarUsuario(String id, String direc) throws DAOException;
	
	
}
