<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Problema - Backtracking</title>
<link href="estiloProb.css" rel="stylesheet" type="text/css">
</head>
<body>




<br>
<%
HttpSession sesion = request.getSession(true);
String decla = (String)sesion.getAttribute("problemaBACK.declaracion");
String problema = (String)sesion.getAttribute("problemaBACK.problema");
String generarHermano = (String)sesion.getAttribute("problemaBACK.generarHermano");
String aumentarNivel = (String)sesion.getAttribute("problemaBACK.aumentarNivel");
String retrocederNivel = (String)sesion.getAttribute("problemaBACK.retrocederNivel");
String tratarSolucion = (String)sesion.getAttribute("problemaBACK.tratarSolucion");
String criterio = (String)sesion.getAttribute("problemaBACK.criterio");
String masHermanos = (String)sesion.getAttribute("problemaBACK.masHermanos");
String condicionParada = (String)sesion.getAttribute("problemaBACK.condicionParada");
String solucion = (String)sesion.getAttribute("problemaBACK.solucion");
String delete = (String)sesion.getAttribute("problemaBACK.delete");
String otras = (String)sesion.getAttribute("problemaBACK.otras");
%>
<div id="contenedor">
<div id="cabecera" class="capa">
<div id="logo" class="capa"><img src="imagenes/logo.jpg"></img></div>
<div id="tituloalgoritmo" class="capa">
<h1>Backtracking</h1>
</div>

</div>
<div id="menuprincipal" class="capa">

<div id="usuario" class="capa">
<%
	
	String id = (String) sesion.getAttribute("id");
%> Hola <%=id%>
			<script>
				<% if (id==null || id.equals("")){%>
						alert('Su sesin a caducado');
						window.location='index.jsp';
				<%}%>
			</script>
<p><a href="cambiarcontrasena.jsp">Cambiar contrasea</a><br />

<a href="index.jsp">Desconectar</a></p>
</div>

<div id="algoritmos" class="capa">
<div id="algoritmos_titulo" class="titulo_menu">Esquemas
algortmicos</div>
<ul >
			<li><a href="principal.jsp">Pgina Principal</a></li>
			<li><a href="DYV.jsp">Divide y Vencers</a></li>
			<li>Ramificacin y Poda</li>
			<ul >
			<li ><a href="rypMini.jsp">Minimizacin</a></li>
			<li ><a href="rypMaxi.jsp">Maximizacin</a></li>
		   </ul>
			<li><a href="PD.jsp">Programacin Dinmica</a></li>
			<li><a href="backtracking.jsp">Backtracking</a></li>
</ul>
</div>
<div id="enlaces" class="capa">
<div id="enlaces_titulo" class="titulo_menu">Enlaces de inters</div>
<ul>
	<li><a href="http://dis.um.es/~ginesgm/aed.html">Algoritmos y
	Estructuras de Datos</a></li>
	<li><a href="http://en.wikipedia.org/wiki/C%2B%2B">C++
	Wikipedia</a></li>
</ul>


</div>
</div>
<div id="principal" class="capa">

<div id="menu" class="capa">
<div id="boton_menu" class="capa">
<form method=POST name="Fichero" enctype='multipart/form-data'
	" action="cargarFicheroProblemaBACK.ctrl"><input type="file"
	name="fich"></input>
</div>
<div id="boton_menu" class="capa"><input class="boton" type=submit
	onclick="" value="Cargar Fichero de Codigo">
</form>
</div>

<div id="boton_menu" class="capa">
<a href="backtracking.jsp" style="text-decoration: none"> 
<input class="boton" type="button" name="volver" value="Volver"></a>
</div>
		

<div id="boton_menu" class="capa">
<form method=POST name="problemaBACK" action="problemaBACK.ctrl">
<input class="boton" type=submit value="Cargar problema">
</div>

<div id="boton_menu" class="capa">

<input class="boton" type="button" value="Utilizar la Lista" 
onclick="window.open('ayuda.jsp?cr=UtilizarLista&titulo=Utilizar la Lista','','left=100,top=100,width=400,height=500,location=no,status=no,scrollbars=yes');return false;"/>
</div>
</div>
<div id="edicion" class="capa">
<a name="declaracion"></a>
<textarea name="declaracion" class="areacodigo">
<%if (decla!=null && !decla.equals("")){ %>
<%=decla%>
<%}
else{%>
#include "nodo.cpp"
#include "lista.cpp"


class Problema {
//Declaraciones privadas de la clase
private:
double *p;
double *b;
int tam;
double M;
Nodo *sol;


//Declaraciones publicas de la clase
public:

Problema();
Nodo *generarHermano(Nodo *nodo);
Nodo *aumentarNivel(Nodo *nodo);
Nodo *retrocederNivel(Nodo *nodo);
void tratarSolucion(Nodo *nodo);
bool criterio(Nodo *nodo);
bool masHermanos(Nodo *nodo);
bool condicionParada(Nodo *nodo);
bool solucion(Nodo *nodo);
~Problema();

};
<%} %>
</textarea>
<br>
<a name="problema"></a>
<textarea name="problema" class="areacodigo">
<%if (problema!=null && !problema.equals("")){ %>
<%=problema%>
<%}
else{%>
Problema::Problema() {

}
<%} %>
</textarea><br>
<a name="generarHermano"></a>
<textarea name="generarHermano" class="areacodigo">
<%if (generarHermano!=null && !generarHermano.equals("")){ %>
<%=generarHermano%>
<%}
else{%>
Nodo *Problema::generarHermano(Nodo *nodo){


}
<%} %>
</textarea><br>
<a name="aumentarNivel"></a>
<textarea name="aumentarNivel" class="areacodigo">
<%if (aumentarNivel!=null && !aumentarNivel.equals("")){ %>
<%=aumentarNivel%>
<%}
else{%>
Nodo *Problema::aumentarNivel(Nodo *nodo) {

}
<%} %>
</textarea><br>
<a name="retrocederNivel"></a>
<textarea name="retrocederNivel" class="areacodigo">
<%if (retrocederNivel!=null && !retrocederNivel.equals("")){ %>
<%=retrocederNivel%>
<%}
else{%>
Nodo *Problema::retrocederNivel(Nodo *nodo) {

}
<%} %>
</textarea><br>
<a name="tratarSolucion"></a>
<textarea name="tratarSolucion" class="areacodigo">
<%if (tratarSolucion!=null && !tratarSolucion.equals("")){ %>
<%=tratarSolucion%>
<%}
else{%>
void Problema::tratarSolucion(Nodo *nodo) {
/********************************************************/
/*************PULSE SOBRE EL BOTN**************/
/*********DE COMO UTILIZAR LAS LISTAS**********/
/***************SITUADO ARRIBA.********************
/*******************************************************/

}
<%} %>
</textarea><br>
<a name="criterio"></a>
<textarea name = "criterio" class="areacodigo">
<%if (criterio!=null && !criterio.equals("")){ %>
<%=criterio%>
<%}
else{%>
bool Problema::criterio(Nodo *nodo){

}
<% }%>
</textarea><br>
<a name="masHermanos"></a>
<textarea name="masHermanos" class="areacodigo">
<%if (masHermanos!=null && !masHermanos.equals("")){ %>
<%=masHermanos%>
<%}
else{%>
bool Problema::masHermanos(Nodo *nodo) {

}
<%} %>
</textarea>

<br>
<a name="condicionParada"></a>
<textarea name="condicionParada" class="areacodigo">
<%if (condicionParada!=null && !condicionParada.equals("")){ %>
<%=condicionParada%>
<%}
else{%>
bool Problema::condicionParada(Nodo *nodo){

}
<%} %>
</textarea><br>

<a name="solucion"></a>
<textarea name="solucion" class="areacodigo">
<%if (solucion!=null && !solucion.equals("")){ %>
<%=solucion%>
<%}
else{%>
bool Problema::solucion(Nodo *nodo){

}
<%} %>
</textarea><br>

<a name="delete"></a>
<textarea name="delete" class="areacodigo">
<%if (delete!=null && !delete.equals("")){ %>
<%=delete%>
<%}
else{%>
Problema::~Problema() {

}
<%} %>
</textarea><br>
<a name="otras"></a>
<textarea name="otras" class="areacodigo">
<%if (otras!=null && !otras.equals("")){ %>
<%=otras%>
<%}
else{%>
//Otras funciones auxiliares
<%} %>
</textarea><br>
</form>
</div>



</div>


</div>
</body>


</html>